/*
Copyright [2020] [bvn13]

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

package com.bvn13.covid19.site.model;

import com.bvn13.covid19.model.entities.StatsProvider;
import lombok.Builder;
import lombok.Value;

@Builder(toBuilder = true)
@Value
public class CovidData implements StatsProvider {

    String region;
    long sick;
    long healed;
    long died;

    Delta previous;

    @Builder
    @Value
    public static class Delta implements StatsProvider {
        long sick;
        long healed;
        long died;
    }

}
